(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms'), require('@ss-dynamic-forms/core'), require('@angular/common'), require('angular2-text-mask')) :
    typeof define === 'function' && define.amd ? define('@ss-dynamic-forms/ui-basic', ['exports', '@angular/core', '@angular/forms', '@ss-dynamic-forms/core', '@angular/common', 'angular2-text-mask'], factory) :
    (global = global || self, factory((global.ngDynamicForms = global.ngDynamicForms || {}, global.ngDynamicForms.ui = global.ngDynamicForms.ui || {}, global.ngDynamicForms.ui.basic = {}), global.ng.core, global.ng.forms, global.ngDynamicForms.core, global.ng.common, global['angular2-text-mask']));
}(this, (function (exports, core, forms, core$1, common, angular2TextMask) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __exportStar(m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m) return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/checkbox/dynamic-basic-checkbox.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DynamicBasicCheckboxComponent = /** @class */ (function (_super) {
        __extends(DynamicBasicCheckboxComponent, _super);
        function DynamicBasicCheckboxComponent(layoutService, validationService) {
            var _this = _super.call(this, layoutService, validationService) || this;
            _this.layoutService = layoutService;
            _this.validationService = validationService;
            _this.blur = new core.EventEmitter();
            _this.change = new core.EventEmitter();
            _this.focus = new core.EventEmitter();
            return _this;
        }
        DynamicBasicCheckboxComponent.decorators = [
            { type: core.Component, args: [{
                        selector: "dynamic-basic-checkbox",
                        template: "<label [formGroup]=\"group\" [ngClass]=\"[getClass('element', 'control'), getClass('grid', 'control')]\">\n\n    <input type=\"checkbox\"\n           [checked]=\"model.checked\"\n           [formControlName]=\"model.id\"\n           [id]=\"elementId\"\n           [indeterminate]=\"model.indeterminate\"\n           [name]=\"model.name\"\n           [required]=\"model.required\"\n           [tabindex]=\"model.tabIndex\"\n           [value]=\"model.value\"\n           (blur)=\"onBlur($event)\"\n           (change)=\"onChange($event)\"\n           (focus)=\"onFocus($event)\"/><span [ngClass]=\"getClass('element', 'label')\"\n                                            [innerHTML]=\"model.label\"></span></label>\n",
                        changeDetection: core.ChangeDetectionStrategy.OnPush
                    }] }
        ];
        /** @nocollapse */
        DynamicBasicCheckboxComponent.ctorParameters = function () { return [
            { type: core$1.DynamicFormLayoutService },
            { type: core$1.DynamicFormValidationService }
        ]; };
        DynamicBasicCheckboxComponent.propDecorators = {
            group: [{ type: core.Input }],
            layout: [{ type: core.Input }],
            model: [{ type: core.Input }],
            blur: [{ type: core.Output }],
            change: [{ type: core.Output }],
            focus: [{ type: core.Output }]
        };
        return DynamicBasicCheckboxComponent;
    }(core$1.DynamicFormControlComponent));
    if (false) {
        /** @type {?} */
        DynamicBasicCheckboxComponent.prototype.group;
        /** @type {?} */
        DynamicBasicCheckboxComponent.prototype.layout;
        /** @type {?} */
        DynamicBasicCheckboxComponent.prototype.model;
        /** @type {?} */
        DynamicBasicCheckboxComponent.prototype.blur;
        /** @type {?} */
        DynamicBasicCheckboxComponent.prototype.change;
        /** @type {?} */
        DynamicBasicCheckboxComponent.prototype.focus;
        /**
         * @type {?}
         * @protected
         */
        DynamicBasicCheckboxComponent.prototype.layoutService;
        /**
         * @type {?}
         * @protected
         */
        DynamicBasicCheckboxComponent.prototype.validationService;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/form-array/dynamic-basic-form-array.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DynamicBasicFormArrayComponent = /** @class */ (function (_super) {
        __extends(DynamicBasicFormArrayComponent, _super);
        function DynamicBasicFormArrayComponent(layoutService, validationService) {
            var _this = _super.call(this, layoutService, validationService) || this;
            _this.layoutService = layoutService;
            _this.validationService = validationService;
            _this.blur = new core.EventEmitter();
            _this.change = new core.EventEmitter();
            _this.customEvent = new core.EventEmitter();
            _this.focus = new core.EventEmitter();
            return _this;
        }
        DynamicBasicFormArrayComponent.decorators = [
            { type: core.Component, args: [{
                        selector: "dynamic-basic-form-array",
                        template: "<ng-container [formGroup]=\"group\">\n\n    <div [formArrayName]=\"model.id\" [id]=\"elementId\" [ngClass]=\"getClass('element', 'control')\">\n\n        <div *ngFor=\"let groupModel of model.groups; let idx = index\" role=\"group\"\n             [formGroupName]=\"idx\" [ngClass]=\"[getClass('element', 'group'), getClass('grid', 'group')]\">\n\n            <ng-container *ngTemplateOutlet=\"startTemplate?.templateRef; context: groupModel\"></ng-container>\n\n            <dynamic-basic-form-control *ngFor=\"let _model of groupModel.group\"\n                                        [context]=\"groupModel\"\n                                        [group]=\"array.at(idx)\"\n                                        [hidden]=\"_model.hidden\"\n                                        [layout]=\"layout\"\n                                        [model]=\"_model\"\n                                        [templates]=\"templates\"\n                                        [ngClass]=\"[getClass('element', 'host', _model), getClass('grid', 'host', _model),\n                                                    getClass('element','children'), getClass('grid','children')]\"\n                                        (blur)=\"onBlur($event)\"\n                                        (change)=\"onChange($event)\"\n                                        (focus)=\"onFocus($event)\"\n                                        (bsEvent)=\"onCustomEvent($event, null, true)\"></dynamic-basic-form-control>\n\n            <ng-container *ngTemplateOutlet=\"endTemplate?.templateRef; context: groupModel\"></ng-container>\n\n        </div>\n\n    </div>\n\n</ng-container>\n"
                    }] }
        ];
        /** @nocollapse */
        DynamicBasicFormArrayComponent.ctorParameters = function () { return [
            { type: core$1.DynamicFormLayoutService },
            { type: core$1.DynamicFormValidationService }
        ]; };
        DynamicBasicFormArrayComponent.propDecorators = {
            group: [{ type: core.Input }],
            layout: [{ type: core.Input }],
            model: [{ type: core.Input }],
            templates: [{ type: core.Input }],
            blur: [{ type: core.Output }],
            change: [{ type: core.Output }],
            customEvent: [{ type: core.Output }],
            focus: [{ type: core.Output }]
        };
        return DynamicBasicFormArrayComponent;
    }(core$1.DynamicFormArrayComponent));
    if (false) {
        /** @type {?} */
        DynamicBasicFormArrayComponent.prototype.group;
        /** @type {?} */
        DynamicBasicFormArrayComponent.prototype.layout;
        /** @type {?} */
        DynamicBasicFormArrayComponent.prototype.model;
        /** @type {?} */
        DynamicBasicFormArrayComponent.prototype.templates;
        /** @type {?} */
        DynamicBasicFormArrayComponent.prototype.blur;
        /** @type {?} */
        DynamicBasicFormArrayComponent.prototype.change;
        /** @type {?} */
        DynamicBasicFormArrayComponent.prototype.customEvent;
        /** @type {?} */
        DynamicBasicFormArrayComponent.prototype.focus;
        /**
         * @type {?}
         * @protected
         */
        DynamicBasicFormArrayComponent.prototype.layoutService;
        /**
         * @type {?}
         * @protected
         */
        DynamicBasicFormArrayComponent.prototype.validationService;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/form-group/dynamic-basic-form-group.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DynamicBasicFormGroupComponent = /** @class */ (function (_super) {
        __extends(DynamicBasicFormGroupComponent, _super);
        function DynamicBasicFormGroupComponent(layoutService, validationService) {
            var _this = _super.call(this, layoutService, validationService) || this;
            _this.layoutService = layoutService;
            _this.validationService = validationService;
            _this.blur = new core.EventEmitter();
            _this.change = new core.EventEmitter();
            _this.customEvent = new core.EventEmitter();
            _this.focus = new core.EventEmitter();
            return _this;
        }
        DynamicBasicFormGroupComponent.decorators = [
            { type: core.Component, args: [{
                        selector: "dynamic-basic-form-group",
                        template: "<ng-container [formGroup]=\"group\">\n\n    <fieldset [formGroupName]=\"model.id\"\n              [id]=\"elementId\"\n              [name]=\"model.name\"\n              [ngClass]=\"getClass('element', 'control')\">\n\n        <legend *ngIf=\"model.legend\" [innerHTML]=\"model.legend\"></legend>\n\n        <dynamic-basic-form-control *ngFor=\"let _model of model.group\"\n                                    [group]=\"control\"\n                                    [hidden]=\"_model.hidden\"\n                                    [layout]=\"layout\"\n                                    [model]=\"_model\"\n                                    [templates]=\"templates\"\n                                    [ngClass]=\"[getClass('element', 'host', _model), getClass('grid', 'host', _model),\n                                                getClass('element','children'), getClass('grid','children')]\"\n                                    (blur)=\"onBlur($event)\"\n                                    (change)=\"onChange($event)\"\n                                    (focus)=\"onFocus($event)\"\n                                    (bsEvent)=\"onCustomEvent($event, null, true)\"></dynamic-basic-form-control>\n    </fieldset>\n\n</ng-container>\n"
                    }] }
        ];
        /** @nocollapse */
        DynamicBasicFormGroupComponent.ctorParameters = function () { return [
            { type: core$1.DynamicFormLayoutService },
            { type: core$1.DynamicFormValidationService }
        ]; };
        DynamicBasicFormGroupComponent.propDecorators = {
            group: [{ type: core.Input }],
            layout: [{ type: core.Input }],
            model: [{ type: core.Input }],
            templates: [{ type: core.Input }],
            blur: [{ type: core.Output }],
            change: [{ type: core.Output }],
            customEvent: [{ type: core.Output }],
            focus: [{ type: core.Output }]
        };
        return DynamicBasicFormGroupComponent;
    }(core$1.DynamicFormControlComponent));
    if (false) {
        /** @type {?} */
        DynamicBasicFormGroupComponent.prototype.group;
        /** @type {?} */
        DynamicBasicFormGroupComponent.prototype.layout;
        /** @type {?} */
        DynamicBasicFormGroupComponent.prototype.model;
        /** @type {?} */
        DynamicBasicFormGroupComponent.prototype.templates;
        /** @type {?} */
        DynamicBasicFormGroupComponent.prototype.blur;
        /** @type {?} */
        DynamicBasicFormGroupComponent.prototype.change;
        /** @type {?} */
        DynamicBasicFormGroupComponent.prototype.customEvent;
        /** @type {?} */
        DynamicBasicFormGroupComponent.prototype.focus;
        /**
         * @type {?}
         * @protected
         */
        DynamicBasicFormGroupComponent.prototype.layoutService;
        /**
         * @type {?}
         * @protected
         */
        DynamicBasicFormGroupComponent.prototype.validationService;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/input/dynamic-basic-input.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DynamicBasicInputComponent = /** @class */ (function (_super) {
        __extends(DynamicBasicInputComponent, _super);
        function DynamicBasicInputComponent(layoutService, validationService) {
            var _this = _super.call(this, layoutService, validationService) || this;
            _this.layoutService = layoutService;
            _this.validationService = validationService;
            _this.blur = new core.EventEmitter();
            _this.change = new core.EventEmitter();
            _this.focus = new core.EventEmitter();
            return _this;
        }
        DynamicBasicInputComponent.decorators = [
            { type: core.Component, args: [{
                        selector: "dynamic-basic-input",
                        template: "<div [formGroup]=\"group\">\n\n    <input [attr.accept]=\"model.accept\"\n           [attr.max]=\"model.max\"\n           [attr.min]=\"model.min\"\n           [attr.multiple]=\"model.multiple\"\n           [attr.step]=\"model.step\"\n           [autocomplete]=\"model.autoComplete\"\n           [autofocus]=\"model.autoFocus\"\n           [dynamicList]=\"model.listId\"\n           [formControlName]=\"model.id\"\n           [id]=\"elementId\"\n           [maxlength]=\"model.maxLength\"\n           [minlength]=\"model.minLength\"\n           [name]=\"model.name\"\n           [ngClass]=\"[getClass('element', 'control'), getClass('grid', 'control')]\"\n           [pattern]=\"model.pattern\"\n           [placeholder]=\"model.placeholder\"\n           [readonly]=\"model.readOnly\"\n           [required]=\"model.required\"\n           [spellcheck]=\"model.spellCheck\"\n           [tabindex]=\"model.tabIndex\"\n           [textMask]=\"{mask: (model.mask || false), showMask: model.mask && !(model.placeholder)}\"\n           [type]=\"model.inputType\"\n           (blur)=\"onBlur($event)\"\n           (change)=\"onChange($event)\"\n           (focus)=\"onFocus($event)\"/>\n\n    <datalist *ngIf=\"model.hasList\" [id]=\"model.listId\">\n\n        <option *ngFor=\"let option of model.list$ | async\" [value]=\"option\">\n\n    </datalist>\n\n</div>\n",
                        changeDetection: core.ChangeDetectionStrategy.OnPush
                    }] }
        ];
        /** @nocollapse */
        DynamicBasicInputComponent.ctorParameters = function () { return [
            { type: core$1.DynamicFormLayoutService },
            { type: core$1.DynamicFormValidationService }
        ]; };
        DynamicBasicInputComponent.propDecorators = {
            group: [{ type: core.Input }],
            layout: [{ type: core.Input }],
            model: [{ type: core.Input }],
            blur: [{ type: core.Output }],
            change: [{ type: core.Output }],
            focus: [{ type: core.Output }]
        };
        return DynamicBasicInputComponent;
    }(core$1.DynamicFormControlComponent));
    if (false) {
        /** @type {?} */
        DynamicBasicInputComponent.prototype.group;
        /** @type {?} */
        DynamicBasicInputComponent.prototype.layout;
        /** @type {?} */
        DynamicBasicInputComponent.prototype.model;
        /** @type {?} */
        DynamicBasicInputComponent.prototype.blur;
        /** @type {?} */
        DynamicBasicInputComponent.prototype.change;
        /** @type {?} */
        DynamicBasicInputComponent.prototype.focus;
        /**
         * @type {?}
         * @protected
         */
        DynamicBasicInputComponent.prototype.layoutService;
        /**
         * @type {?}
         * @protected
         */
        DynamicBasicInputComponent.prototype.validationService;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/radio-group/dynamic-basic-radio-group.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DynamicBasicRadioGroupComponent = /** @class */ (function (_super) {
        __extends(DynamicBasicRadioGroupComponent, _super);
        function DynamicBasicRadioGroupComponent(layoutService, validationService) {
            var _this = _super.call(this, layoutService, validationService) || this;
            _this.layoutService = layoutService;
            _this.validationService = validationService;
            _this.blur = new core.EventEmitter();
            _this.change = new core.EventEmitter();
            _this.focus = new core.EventEmitter();
            return _this;
        }
        DynamicBasicRadioGroupComponent.decorators = [
            { type: core.Component, args: [{
                        selector: "dynamic-basic-radio-group",
                        template: "<fieldset role=\"radiogroup\"\n          [formGroup]=\"group\"\n          [id]=\"elementId\"\n          [name]=\"model.name\"\n          [ngClass]=\"[getClass('element', 'control'), getClass('grid', 'control')]\"\n          [tabindex]=\"model.tabIndex\"\n          (change)=\"onChange($event)\">\n\n    <legend *ngIf=\"model.legend\" [innerHTML]=\"model.legend\"></legend>\n\n    <label *ngFor=\"let option of model.options$ | async\" [ngClass]=\"getClass('element', 'option')\">\n\n        <input type=\"radio\"\n               [formControlName]=\"model.id\"\n               [name]=\"model.name\"\n               [value]=\"option.value\"\n               (blur)=\"onBlur($event)\"\n               (focus)=\"onFocus($event)\"/><span [innerHTML]=\"option.label\"></span></label>\n</fieldset>\n",
                        changeDetection: core.ChangeDetectionStrategy.OnPush
                    }] }
        ];
        /** @nocollapse */
        DynamicBasicRadioGroupComponent.ctorParameters = function () { return [
            { type: core$1.DynamicFormLayoutService },
            { type: core$1.DynamicFormValidationService }
        ]; };
        DynamicBasicRadioGroupComponent.propDecorators = {
            group: [{ type: core.Input }],
            layout: [{ type: core.Input }],
            model: [{ type: core.Input }],
            blur: [{ type: core.Output }],
            change: [{ type: core.Output }],
            focus: [{ type: core.Output }]
        };
        return DynamicBasicRadioGroupComponent;
    }(core$1.DynamicFormControlComponent));
    if (false) {
        /** @type {?} */
        DynamicBasicRadioGroupComponent.prototype.group;
        /** @type {?} */
        DynamicBasicRadioGroupComponent.prototype.layout;
        /** @type {?} */
        DynamicBasicRadioGroupComponent.prototype.model;
        /** @type {?} */
        DynamicBasicRadioGroupComponent.prototype.blur;
        /** @type {?} */
        DynamicBasicRadioGroupComponent.prototype.change;
        /** @type {?} */
        DynamicBasicRadioGroupComponent.prototype.focus;
        /**
         * @type {?}
         * @protected
         */
        DynamicBasicRadioGroupComponent.prototype.layoutService;
        /**
         * @type {?}
         * @protected
         */
        DynamicBasicRadioGroupComponent.prototype.validationService;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/select/dynamic-basic-select.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DynamicBasicSelectComponent = /** @class */ (function (_super) {
        __extends(DynamicBasicSelectComponent, _super);
        function DynamicBasicSelectComponent(layoutService, validationService) {
            var _this = _super.call(this, layoutService, validationService) || this;
            _this.layoutService = layoutService;
            _this.validationService = validationService;
            _this.blur = new core.EventEmitter();
            _this.change = new core.EventEmitter();
            _this.focus = new core.EventEmitter();
            return _this;
        }
        DynamicBasicSelectComponent.decorators = [
            { type: core.Component, args: [{
                        selector: "dynamic-basic-select",
                        template: "<ng-container [formGroup]=\"group\">\n\n    <select [compareWith]=\"model.compareWithFn\"\n            [formControlName]=\"model.id\"\n            [id]=\"elementId\"\n            [name]=\"model.name\"\n            [ngClass]=\"[getClass('element', 'control'), getClass('grid', 'control')]\"\n            [required]=\"model.required\"\n            [tabindex]=\"model.tabIndex\"\n            (blur)=\"onBlur($event)\"\n            (change)=\"onChange($event)\"\n            (focus)=\"onFocus($event)\">\n\n        <option *ngFor=\"let option of model.options$ | async\"\n                [disabled]=\"option.disabled\"\n                [ngValue]=\"option.value\">{{ option.label }}\n        </option>\n\n    </select>\n\n</ng-container>\n",
                        changeDetection: core.ChangeDetectionStrategy.OnPush
                    }] }
        ];
        /** @nocollapse */
        DynamicBasicSelectComponent.ctorParameters = function () { return [
            { type: core$1.DynamicFormLayoutService },
            { type: core$1.DynamicFormValidationService }
        ]; };
        DynamicBasicSelectComponent.propDecorators = {
            group: [{ type: core.Input }],
            layout: [{ type: core.Input }],
            model: [{ type: core.Input }],
            blur: [{ type: core.Output }],
            change: [{ type: core.Output }],
            focus: [{ type: core.Output }]
        };
        return DynamicBasicSelectComponent;
    }(core$1.DynamicFormControlComponent));
    if (false) {
        /** @type {?} */
        DynamicBasicSelectComponent.prototype.group;
        /** @type {?} */
        DynamicBasicSelectComponent.prototype.layout;
        /** @type {?} */
        DynamicBasicSelectComponent.prototype.model;
        /** @type {?} */
        DynamicBasicSelectComponent.prototype.blur;
        /** @type {?} */
        DynamicBasicSelectComponent.prototype.change;
        /** @type {?} */
        DynamicBasicSelectComponent.prototype.focus;
        /**
         * @type {?}
         * @protected
         */
        DynamicBasicSelectComponent.prototype.layoutService;
        /**
         * @type {?}
         * @protected
         */
        DynamicBasicSelectComponent.prototype.validationService;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/textarea/dynamic-basic-textarea.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DynamicBasicTextAreaComponent = /** @class */ (function (_super) {
        __extends(DynamicBasicTextAreaComponent, _super);
        function DynamicBasicTextAreaComponent(layoutService, validationService) {
            var _this = _super.call(this, layoutService, validationService) || this;
            _this.layoutService = layoutService;
            _this.validationService = validationService;
            _this.blur = new core.EventEmitter();
            _this.change = new core.EventEmitter();
            _this.focus = new core.EventEmitter();
            return _this;
        }
        DynamicBasicTextAreaComponent.decorators = [
            { type: core.Component, args: [{
                        selector: "dynamic-basic-textarea",
                        template: "<ng-container [formGroup]=\"group\">\n\n    <textarea [cols]=\"model.cols\"\n              [formControlName]=\"model.id\"\n              [id]=\"elementId\"\n              [maxlength]=\"model.maxLength\"\n              [minlength]=\"model.minLength\"\n              [name]=\"model.name\"\n              [ngClass]=\"[getClass('element', 'control'), getClass('grid', 'control')]\"\n              [placeholder]=\"model.placeholder\"\n              [readonly]=\"model.readOnly\"\n              [required]=\"model.required\"\n              [rows]=\"model.rows\"\n              [spellcheck]=\"model.spellCheck\"\n              [tabindex]=\"model.tabIndex\"\n              [wrap]=\"model.wrap\"\n              (blur)=\"onBlur($event)\"\n              (change)=\"onChange($event)\"\n              (focus)=\"onFocus($event)\"></textarea>\n\n</ng-container>\n",
                        changeDetection: core.ChangeDetectionStrategy.OnPush
                    }] }
        ];
        /** @nocollapse */
        DynamicBasicTextAreaComponent.ctorParameters = function () { return [
            { type: core$1.DynamicFormLayoutService },
            { type: core$1.DynamicFormValidationService }
        ]; };
        DynamicBasicTextAreaComponent.propDecorators = {
            group: [{ type: core.Input }],
            layout: [{ type: core.Input }],
            model: [{ type: core.Input }],
            blur: [{ type: core.Output }],
            change: [{ type: core.Output }],
            focus: [{ type: core.Output }]
        };
        return DynamicBasicTextAreaComponent;
    }(core$1.DynamicFormControlComponent));
    if (false) {
        /** @type {?} */
        DynamicBasicTextAreaComponent.prototype.group;
        /** @type {?} */
        DynamicBasicTextAreaComponent.prototype.layout;
        /** @type {?} */
        DynamicBasicTextAreaComponent.prototype.model;
        /** @type {?} */
        DynamicBasicTextAreaComponent.prototype.blur;
        /** @type {?} */
        DynamicBasicTextAreaComponent.prototype.change;
        /** @type {?} */
        DynamicBasicTextAreaComponent.prototype.focus;
        /**
         * @type {?}
         * @protected
         */
        DynamicBasicTextAreaComponent.prototype.layoutService;
        /**
         * @type {?}
         * @protected
         */
        DynamicBasicTextAreaComponent.prototype.validationService;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/dynamic-basic-form-control-container.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DynamicBasicFormControlContainerComponent = /** @class */ (function (_super) {
        __extends(DynamicBasicFormControlContainerComponent, _super);
        function DynamicBasicFormControlContainerComponent(componentFactoryResolver, layoutService, validationService, componentService, relationService) {
            var _this = _super.call(this, componentFactoryResolver, layoutService, validationService, componentService, relationService) || this;
            _this.componentFactoryResolver = componentFactoryResolver;
            _this.layoutService = layoutService;
            _this.validationService = validationService;
            _this.componentService = componentService;
            _this.relationService = relationService;
            _this.context = null;
            _this.blur = new core.EventEmitter();
            _this.change = new core.EventEmitter();
            _this.focus = new core.EventEmitter();
            return _this;
        }
        Object.defineProperty(DynamicBasicFormControlContainerComponent.prototype, "componentType", {
            get: /**
             * @return {?}
             */
            function () {
                return this.componentService.getCustomComponentType(this.model) || basicUIFormControlMapFn(this.model);
            },
            enumerable: true,
            configurable: true
        });
        DynamicBasicFormControlContainerComponent.decorators = [
            { type: core.Component, args: [{
                        selector: "dynamic-basic-form-control",
                        template: "<div [formGroup]=\"group\" [ngClass]=\"['ss-dynamic-forms-'+model.type.toLowerCase(), getClass('element', 'container'), getClass('grid', 'container')]\">\n\n    <label *ngIf=\"!isCheckbox && hasLabel\"\n           [for]=\"elementId\"\n           [innerHTML]=\"model.label\"\n           [ngClass]=\"[getClass('element', 'label'), getClass('grid', 'label')]\"></label>\n\n    <ng-container *ngTemplateOutlet=\"startTemplate?.templateRef; context: model\"></ng-container>\n\n    <ng-container #componentViewContainer></ng-container>\n\n    <div *ngIf=\"hasHint\" [ngClass]=\"[getClass('element', 'hint'), getClass('grid', 'hint')]\">\n        <span [innerHTML]=\"hint\"></span>\n    </div>\n\n    <ul *ngIf=\"showErrorMessages\" [ngClass]=\"[getClass('element', 'errors'), getClass('grid', 'errors')]\">\n        <li *ngFor=\"let message of errorMessages\">{{ message }}</li>\n    </ul>\n\n    <ng-container *ngTemplateOutlet=\"endTemplate?.templateRef; context: model\"></ng-container>\n\n    <ng-content></ng-content>\n\n</div>\n"
                    }] }
        ];
        /** @nocollapse */
        DynamicBasicFormControlContainerComponent.ctorParameters = function () { return [
            { type: core.ComponentFactoryResolver },
            { type: core$1.DynamicFormLayoutService },
            { type: core$1.DynamicFormValidationService },
            { type: core$1.DynamicFormComponentService },
            { type: core$1.DynamicFormRelationService }
        ]; };
        DynamicBasicFormControlContainerComponent.propDecorators = {
            contentTemplateList: [{ type: core.ContentChildren, args: [core$1.DynamicTemplateDirective,] }],
            inputTemplateList: [{ type: core.Input, args: ["templates",] }],
            context: [{ type: core.Input }],
            group: [{ type: core.Input }],
            layout: [{ type: core.Input }],
            model: [{ type: core.Input }],
            blur: [{ type: core.Output }],
            change: [{ type: core.Output }],
            focus: [{ type: core.Output }],
            componentViewContainerRef: [{ type: core.ViewChild, args: ["componentViewContainer", { read: core.ViewContainerRef, static: true },] }]
        };
        return DynamicBasicFormControlContainerComponent;
    }(core$1.DynamicFormControlContainerComponent));
    if (false) {
        /** @type {?} */
        DynamicBasicFormControlContainerComponent.prototype.contentTemplateList;
        /** @type {?} */
        DynamicBasicFormControlContainerComponent.prototype.inputTemplateList;
        /** @type {?} */
        DynamicBasicFormControlContainerComponent.prototype.context;
        /** @type {?} */
        DynamicBasicFormControlContainerComponent.prototype.group;
        /** @type {?} */
        DynamicBasicFormControlContainerComponent.prototype.layout;
        /** @type {?} */
        DynamicBasicFormControlContainerComponent.prototype.model;
        /** @type {?} */
        DynamicBasicFormControlContainerComponent.prototype.blur;
        /** @type {?} */
        DynamicBasicFormControlContainerComponent.prototype.change;
        /** @type {?} */
        DynamicBasicFormControlContainerComponent.prototype.focus;
        /** @type {?} */
        DynamicBasicFormControlContainerComponent.prototype.componentViewContainerRef;
        /**
         * @type {?}
         * @protected
         */
        DynamicBasicFormControlContainerComponent.prototype.componentFactoryResolver;
        /**
         * @type {?}
         * @protected
         */
        DynamicBasicFormControlContainerComponent.prototype.layoutService;
        /**
         * @type {?}
         * @protected
         */
        DynamicBasicFormControlContainerComponent.prototype.validationService;
        /**
         * @type {?}
         * @protected
         */
        DynamicBasicFormControlContainerComponent.prototype.componentService;
        /**
         * @type {?}
         * @protected
         */
        DynamicBasicFormControlContainerComponent.prototype.relationService;
    }
    /**
     * @param {?} model
     * @return {?}
     */
    function basicUIFormControlMapFn(model) {
        switch (model.type) {
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_ARRAY:
                return DynamicBasicFormArrayComponent;
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_CHECKBOX:
                return DynamicBasicCheckboxComponent;
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_CHECKBOX_GROUP:
                return DynamicBasicFormGroupComponent;
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_GROUP:
                return DynamicBasicFormGroupComponent;
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_INPUT:
                return DynamicBasicInputComponent;
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_RADIO_GROUP:
                return DynamicBasicRadioGroupComponent;
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_SELECT:
                return DynamicBasicSelectComponent;
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_TEXTAREA:
                return DynamicBasicTextAreaComponent;
            default:
                return null;
        }
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/dynamic-basic-form.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DynamicBasicFormComponent = /** @class */ (function (_super) {
        __extends(DynamicBasicFormComponent, _super);
        function DynamicBasicFormComponent(formService, layoutService) {
            var _this = _super.call(this, formService, layoutService) || this;
            _this.formService = formService;
            _this.layoutService = layoutService;
            _this.blur = new core.EventEmitter();
            _this.change = new core.EventEmitter();
            _this.focus = new core.EventEmitter();
            return _this;
        }
        DynamicBasicFormComponent.decorators = [
            { type: core.Component, args: [{
                        selector: "dynamic-basic-form",
                        template: "<dynamic-basic-form-control *ngFor=\"let model of formModel; trackBy: trackByFn\"\n                            [group]=\"formGroup\"\n                            [hidden]=\"model.hidden\"\n                            [layout]=\"formLayout\"\n                            [model]=\"model\"\n                            [ngClass]=\"[getClass(model,'element','host'), getClass(model,'grid','host')]\"\n                            [templates]=\"templates\"\n                            (blur)=\"onEvent($event, 'blur')\"\n                            (change)=\"onEvent($event, 'change')\"\n                            (focus)=\"onEvent($event, 'focus')\"></dynamic-basic-form-control>"
                    }] }
        ];
        /** @nocollapse */
        DynamicBasicFormComponent.ctorParameters = function () { return [
            { type: core$1.DynamicFormService },
            { type: core$1.DynamicFormLayoutService }
        ]; };
        DynamicBasicFormComponent.propDecorators = {
            formGroup: [{ type: core.Input, args: ["group",] }],
            formModel: [{ type: core.Input, args: ["model",] }],
            formLayout: [{ type: core.Input, args: ["layout",] }],
            blur: [{ type: core.Output }],
            change: [{ type: core.Output }],
            focus: [{ type: core.Output }],
            templates: [{ type: core.ContentChildren, args: [core$1.DynamicTemplateDirective,] }],
            components: [{ type: core.ViewChildren, args: [DynamicBasicFormControlContainerComponent,] }]
        };
        return DynamicBasicFormComponent;
    }(core$1.DynamicFormComponent));
    if (false) {
        /** @type {?} */
        DynamicBasicFormComponent.prototype.formGroup;
        /** @type {?} */
        DynamicBasicFormComponent.prototype.formModel;
        /** @type {?} */
        DynamicBasicFormComponent.prototype.formLayout;
        /** @type {?} */
        DynamicBasicFormComponent.prototype.blur;
        /** @type {?} */
        DynamicBasicFormComponent.prototype.change;
        /** @type {?} */
        DynamicBasicFormComponent.prototype.focus;
        /** @type {?} */
        DynamicBasicFormComponent.prototype.templates;
        /** @type {?} */
        DynamicBasicFormComponent.prototype.components;
        /**
         * @type {?}
         * @protected
         */
        DynamicBasicFormComponent.prototype.formService;
        /**
         * @type {?}
         * @protected
         */
        DynamicBasicFormComponent.prototype.layoutService;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/dynamic-basic-form-ui.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DynamicFormsBasicUIModule = /** @class */ (function () {
        function DynamicFormsBasicUIModule() {
        }
        DynamicFormsBasicUIModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [
                            forms.FormsModule,
                            common.CommonModule,
                            forms.ReactiveFormsModule,
                            angular2TextMask.TextMaskModule,
                            core$1.DynamicFormsCoreModule
                        ],
                        declarations: [
                            DynamicBasicCheckboxComponent,
                            DynamicBasicFormArrayComponent,
                            DynamicBasicFormComponent,
                            DynamicBasicFormControlContainerComponent,
                            DynamicBasicFormGroupComponent,
                            DynamicBasicInputComponent,
                            DynamicBasicRadioGroupComponent,
                            DynamicBasicSelectComponent,
                            DynamicBasicTextAreaComponent
                        ],
                        entryComponents: [
                            DynamicBasicCheckboxComponent,
                            DynamicBasicFormArrayComponent,
                            DynamicBasicFormGroupComponent,
                            DynamicBasicInputComponent,
                            DynamicBasicRadioGroupComponent,
                            DynamicBasicSelectComponent,
                            DynamicBasicTextAreaComponent
                        ],
                        exports: [
                            core$1.DynamicFormsCoreModule,
                            DynamicBasicCheckboxComponent,
                            DynamicBasicFormArrayComponent,
                            DynamicBasicFormComponent,
                            DynamicBasicFormControlContainerComponent,
                            DynamicBasicFormGroupComponent,
                            DynamicBasicInputComponent,
                            DynamicBasicRadioGroupComponent,
                            DynamicBasicSelectComponent,
                            DynamicBasicTextAreaComponent
                        ]
                    },] }
        ];
        return DynamicFormsBasicUIModule;
    }());

    exports.DynamicBasicCheckboxComponent = DynamicBasicCheckboxComponent;
    exports.DynamicBasicFormArrayComponent = DynamicBasicFormArrayComponent;
    exports.DynamicBasicFormComponent = DynamicBasicFormComponent;
    exports.DynamicBasicFormControlContainerComponent = DynamicBasicFormControlContainerComponent;
    exports.DynamicBasicFormGroupComponent = DynamicBasicFormGroupComponent;
    exports.DynamicBasicInputComponent = DynamicBasicInputComponent;
    exports.DynamicBasicRadioGroupComponent = DynamicBasicRadioGroupComponent;
    exports.DynamicBasicSelectComponent = DynamicBasicSelectComponent;
    exports.DynamicBasicTextAreaComponent = DynamicBasicTextAreaComponent;
    exports.DynamicFormsBasicUIModule = DynamicFormsBasicUIModule;
    exports.basicUIFormControlMapFn = basicUIFormControlMapFn;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ui-basic.umd.js.map
